/***************************************************************************

	File: pic_delay.c

	Copyright (C) 2010-2012 S.Suwa <www.suwa-koubou.jp>

	for 16Mhz instruction clock cycle. 
	PIC24FJ64GA002

*/

#include	"pic_delay.h"

/*--------------------------------------------------------------------------
	delay routines
--------------------------------------------------------------------------*/

void delay_ms(unsigned int t)
{
  unsigned int i;

  for (i=0; i<t; i++) {
	asm("repeat #15993");  // for 16MHz clock
	asm("nop");
  }  
}


void delay_10us(unsigned int t)
{
  unsigned int i;

  for (i=0; i<t; i++) {
    asm("repeat #153");  // for 16MHz clock
    asm("nop");
  }  
}


void delay_us(unsigned int t)
{
	unsigned int i;

	for(i=0; i < t; i++){
		asm("repeat #10");	// for 16Mhz clock
		asm("nop");
	}
}


void delay_5us(void)
{
	delay_1us(); delay_1us(); delay_1us(); delay_1us(); 
	asm("repeat #7");	// repeat 1cycle
	asm("nop");			// nop 1cycle * 8(#7+1)
}

void delay_1us(void)
{
	// call 2cycle
	// ret  3cycle
	// lnk  1cycle
	// ulnk	1cycle
	// nop  1cycle x 9
	// total 16cycle, instruction 16cycle/usec

	asm("repeat #7");	// repeat 1cycle
	asm("nop");			// nop 1cycle * 8(#7+1)

}

/*** end of pic_delay.c ****************************************************/
